"use strict";
var _a;
Object.defineProperty(exports, "__esModule", { value: true });
exports.endsWith = exports.isNativeCode = exports.definedKeys = exports.isPlainObject = exports.isNonNullObject = exports.hasOwn = exports.objToStr = exports.getPrototypeOf = exports.fnToStr = void 0;
exports.fnToStr = Function.prototype.toString;
exports.getPrototypeOf = Object.getPrototypeOf, exports.objToStr = (_a = Object.prototype, _a.toString), exports.hasOwn = _a.hasOwnProperty;
function isNonNullObject(obj) {
    return obj !== null && typeof obj === "object";
}
exports.isNonNullObject = isNonNullObject;
function isPlainObject(obj) {
    if (isNonNullObject(obj)) {
        var proto = exports.getPrototypeOf(obj);
        return proto === null || proto === Object.prototype;
    }
    return false;
}
exports.isPlainObject = isPlainObject;
function definedKeys(obj) {
    // Remember that the second argument to Array.prototype.filter will be
    // used as `this` within the callback function.
    return Object.keys(obj).filter(isDefinedKey, obj);
}
exports.definedKeys = definedKeys;
function isDefinedKey(key) {
    return this[key] !== void 0;
}
var nativeCodeSuffix = "{ [native code] }";
function isNativeCode(code) {
    return endsWith(code, nativeCodeSuffix);
}
exports.isNativeCode = isNativeCode;
function endsWith(full, suffix) {
    var fromIndex = full.length - suffix.length;
    return fromIndex >= 0 &&
        full.indexOf(suffix, fromIndex) === fromIndex;
}
exports.endsWith = endsWith;
//# sourceMappingURL=helpers.js.map